<?php
class SchedulesController extends AppController {

	var $name = 'Schedules';
	var $scaffold;
	var $components = array('Calendar', 'Confirm');
	var $helpers = array('ScheduleTable');

	function index($scope='week', $year=false, $month=false, $day=false) {
		if(!$year) $year = date('Y');
		if(!$month) $month = date('m');
		if(!$day) $day = date('d');
		$current = sprintf("%d/%02d/%02d", $year, $month, $day);
		$this->Session->write('SCHEDULE_INDEX_CONDITION', compact('scope', 'current'));

		$times = $this->Calendar->scopeToTimes($scope, $year, $month, $day);
		$schedules = $this->Schedule->findByTimes($times);
		$this->set(compact('schedules', 'scope', 'times', 'current'));
	}

	function redirect($url, $status = null, $exit = true) {
		if(is_array($url) && $url['action'] == 'index') {
			$prev = $this->Session->read('SCHEDULE_INDEX_CONDITION');
			if(!empty($prev)) {
				extract($prev);
				$url['id'] = $scope;
				$url[] = $current;
			}
		}
		return parent::redirect($url, $status, $exit);
	}

}
?>