<?php
class Schedule extends AppModel {

	var $name = 'Schedule';
	var $validate = array(
		'from' => array(
			'date_format' => array('rule' => array('datetime'), 'required' => true),
			'compare_from_to'=> array('rule' => array('compareFromTo')),
			'not_duplicate_schedule' => array('rule' => array('isDuplicate'))
		),
		'to' => array(
			'date_format' => array('rule' => array('datetime'), 'required' => true)
		),
		'title' => array(
			'require' => array('rule' => array('notEmpty'), 'required' => true)
		)
	);

	function findByTimes($times) {
		extract($times);
		$from = date("Y-n-j H:i:s", $from_time);
		$to = date("Y-n-j H:i:s", $to_time);
		$conditions = array('or' => array(
			array("from BETWEEN ? AND ?" => array($from, $to)),
			array("to BETWEEN ? AND ?" => array($from, $to))
		));
		$order = 'from';
		return $this->find('all', compact('conditions', 'order'));
	}
}
?>